
var HelloWorldLayer = cc.Layer.extend({
    ctor:function () {
        this._super();

        this._initShapeEditor();

        return true;
    },
    _initShapeEditor:function() {
        this._shapeEditorVerticesArray = [];
        this._drawNodeVertices = new cc.DrawNode();
        this._drawNodeEdge = new cc.DrawNode();
        this._drawNodeEdges = new cc.DrawNode();
        this._drawNodePoly = new cc.DrawNode();
        this.addChild(this._drawNodePoly);
        this.addChild(this._drawNodeVertices);
        this.addChild(this._drawNodeEdge);
        this.addChild(this._drawNodeEdges);
        var self = this;
        this._shapeEditorEvent = cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var location = touch.getLocation();
                if (self._shapeEditorVerticesArray.length == 0) {
                    self._drawNodeVertices.drawDot(location, 5, cc.color.GREEN);
                    self._shapeEditorVerticesArray.push(location);
                }
                else {
                    self._drawNodeEdge.drawSegment(self._shapeEditorVerticesArray[self._shapeEditorVerticesArray.length - 1], location, 3, cc.color.YELLOW);
                }
                self._plot(location);
                return true;
            },
            onTouchMoved: function (touch, event) {
                if (self._shapeEditorVerticesArray.length > 0) {
                    var location = touch.getLocation();
                    self._drawNodeEdge.clear();
                    self._drawNodeEdge.drawSegment(self._shapeEditorVerticesArray[self._shapeEditorVerticesArray.length - 1], location, 3, cc.color.YELLOW);
                    self._plot(location);
                }
            },
            onTouchEnded: function (touch, event) {
                if (self._shapeEditorVerticesArray.length > 0) {
                    var location = touch.getLocation();
                    // 
                    self._drawNodeEdge.clear();
                    self._drawNodeEdges.drawSegment(self._shapeEditorVerticesArray[self._shapeEditorVerticesArray.length - 1], location, 3, cc.color.YELLOW);
                    self._drawNodeVertices.drawDot(location, 5, cc.color.GREEN);
                    self._shapeEditorVerticesArray.push(location);
                    self._plot();
                }
            }
        }, this);
    },
    _plot:function(position) {
        if (this._shapeEditorVerticesArray.length > 2 || (position && this._shapeEditorVerticesArray.length > 1)) {
            this._drawNodePoly.clear();

            if (position) {
                var ppp = this._shapeEditorVerticesArray.slice();
                ppp.push(position);
                
                cc.log("ppp");
                cc.log(ppp);
                var output = JSON.stringify(ppp, null, 4);
                output = output.replace(/\"x\": /g, "").replace(/\"y\": /g, "").replace(/{/g, "cc.p(").replace(/}/g, ")");
                cc.log(output);
                this._drawNodePoly.drawPoly(ppp, cc.color.RED, 0, cc.color(0, 0, 0, 0));
            }
            else {
                cc.log("this._shapeEditorVerticesArray");
                // cc.log(this._shapeEditorVerticesArray);
                var output = JSON.stringify(this._shapeEditorVerticesArray, null, 4);
                output = output.replace(/\"x\": /g, "").replace(/\"y\": /g, "").replace(/{/g, "cc.p(").replace(/}/g, ")");
                cc.log(output);
                this._drawNodePoly.drawPoly(this._shapeEditorVerticesArray, cc.color.RED, cc.FLT_EPSILON, cc.color(0, 255, 0, 255));
            }
        }        
    }
});

var HelloWorldScene = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new HelloWorldLayer();
        this.addChild(layer);
    }
});

